package net.highesoft.mybatis.hsql;

import java.util.Map;
import java.util.Map.Entry;

import org.apache.ibatis.datasource.unpooled.UnpooledDataSource;
import org.apache.ibatis.mapping.Environment;
import org.apache.ibatis.session.Configuration;
import org.apache.ibatis.session.SqlSession;
import org.apache.ibatis.session.SqlSessionFactory;
import org.apache.ibatis.session.SqlSessionFactoryBuilder;
import org.apache.ibatis.transaction.TransactionFactory;
import org.apache.ibatis.transaction.jdbc.JdbcTransactionFactory;
public class Main {
	//private static Log log=LogFactory.getLog(HsqlTest.class);
	private static SqlSessionFactory sqlSessionFactory;

	public static void startHsql() {
		new Thread() {
			//启动服务器
			public void run() {
				org.hsqldb.server.Server.main(new String[] {});
			}
		}.start();
		new Thread() {
			//启动管理页面
			public void run() {
				org.hsqldb.util.DatabaseManagerSwing.main(new String[] {});
			}
		}.start();
		try {
			Thread.sleep(10000);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
	}

	public static void main(String[] args) {
		startHsql();
		
		UnpooledDataSource ds = new UnpooledDataSource();
		ds.setDriver("org.hsqldb.jdbcDriver");
		ds.setUrl("jdbc:hsqldb:hsql://localhost");
		ds.setUsername("sa");
		ds.setPassword("");
		
		
		TransactionFactory transactionFactory = new JdbcTransactionFactory();
		Environment environment = new Environment("Test", transactionFactory, ds);
		Configuration configuration = new Configuration(environment);
		configuration.setLazyLoadingEnabled(true);
		configuration.setUseActualParamName(false); // to test legacy style reference (#{0} #{1})
		configuration.getTypeAliasRegistry().registerAlias(TestMybatis.class);
		configuration.addMapper(TestMapper.class);
		
		sqlSessionFactory = new SqlSessionFactoryBuilder().build(configuration);
		SqlSession session = sqlSessionFactory.openSession(); 
		TestMapper mapper = session.getMapper(TestMapper.class);
		mapper.createTable();
		mapper.insert();
		Map<Integer,TestMybatis>	m = mapper.selectTestMybatis("test_mybatis");
		for(Entry<Integer,TestMybatis> entry:m.entrySet()) {
			System.out.println(entry.getValue().getName());
		}
			
	}

}
